Package: org.codehaus.groovy.tools.groovydoc

## [Java] Class GroovyDocTool

- org.codehaus.groovy.tools.groovydoc.GroovyDocTool

-     public class GroovyDocTool
      extends Object

  Coordinates source parsing and template-driven rendering for GroovyDoc generation.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected Properties` | `properties` | Rendering properties shared with the parser and template engine.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `GroovyDocTool(String[] sourcepaths)` Constructor for use by people who only want to interact with the Groovy Doclet Tree (rootDoc)
    `GroovyDocTool(ResourceManager resourceManager, String[] sourcepaths, String classTemplate)` Creates a GroovyDocTool with a resource manager, source paths, and a single class-level template.
    `GroovyDocTool(ResourceManager resourceManager, String[] sourcepaths, String[] docTemplates, String[] packageTemplates, String[] classTemplates, List<LinkArgument> links, String javaVersion, Properties properties)` Constructs a GroovyDocTool instance with the specified parameters.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `add(List<String> filenames)` Adds source files to the documentation set.
    `` | `public int` | `getErrorCount()` Returns: the number of source files that could not be parsed
    `` | `public GroovyRootDoc` | `getRootDoc()` Returns the root documentation object built from all added source files.
    `` | `public void` | `renderToOutput(OutputTool output, String destdir)` Renders the collected documentation to the given output using the configured templates.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### protected Properties properties

      Rendering properties shared with the parser and template engine.

  - ### Constructor Detail

    - #### public GroovyDocTool(String[] sourcepaths)

      Constructor for use by people who only want to interact with the Groovy Doclet Tree (rootDoc)

      Parameters:
        `sourcepaths` - where the sources to be added can be found

    - #### public GroovyDocTool(ResourceManager resourceManager, String[] sourcepaths, String classTemplate)

      Creates a GroovyDocTool with a resource manager, source paths, and a single class-level template.

    - #### public GroovyDocTool(ResourceManager resourceManager, String[] sourcepaths, String[] docTemplates, String[] packageTemplates, String[] classTemplates, List<LinkArgument> links, String javaVersion, Properties properties)

      Constructs a GroovyDocTool instance with the specified parameters.

      Parameters:
        `resourceManager` - the resource manager for handling resources, or null if not required
        `sourcepaths` - the paths to the source files to be processed
        `docTemplates` - the templates for generating documentation
        `packageTemplates` - the templates for generating package-level documentation
        `classTemplates` - the templates for generating class-level documentation
        `links` - a list of link arguments for external references
        `javaVersion` - the Java version to be used for parsing and processing Java source files
        `properties` - additional properties to be used when generating the groovydoc

  - ### Method Detail

    - #### public void add(List<String> filenames)

      Adds source files to the documentation set.

      throws:
        IOException if a file cannot be read
      Parameters:
        `filenames` - relative source file paths to process

    - #### public int getErrorCount()

      Returns:
        the number of source files that could not be parsed
      Since:
        6.0.0

    - #### public GroovyRootDoc getRootDoc()

      Returns the root documentation object built from all added source files.

    - #### public void renderToOutput(OutputTool output, String destdir)

      Renders the collected documentation to the given output using the configured templates.

      throws:
        Exception if rendering fails
      Parameters:
        `output` - the output destination
        `destdir` - the destination directory path